alias dbgdll {
  ;prints [DLL] $1- 
  return $1-
}
alias inidir { return $enclose($+(ini\,$1-)) }
alias cfgini { return $inidir(config.ini) }
alias supportdir { return $enclose($+(support\,$1-)) }

alias dur { return $remove($replace($duration($1-),wks,w,wk,w,days,d,day,d,hrs,h,hr,h,mins,m,min,m,secs,s,sec,s),$chr(32)) }

; DLL Helpers - MDX
alias mdxdll { return $supportdir(mdx.dll) }
alias mdxctl { return $remove($supportdir($+($1,.mdx)),") }
alias mdx { return $dll($mdxdll,$1,$2-) }
alias mdxmark {
  dbgdll $mdx(SetMircVersion,$version)
  dbgdll $mdx(MarkDialog,$1)
}
alias mdxpage {
  var %dname, %did
  if ($0 = 1) {
    set %dname $dname
    set %did $1
  }
  else {
    set %dname $1
    set %did $2
  }
  did -i %dname %did 1 page $prop
  return $gettok($did(%dname, %did, 1), 3-, 32)
}

; DLL Helpers - band
alias banddll { return $supportdir(band.dll) }
alias band { return $dll($banddll,$1,$2-) }

alias dim {
  if ($1 == taskbar) {
    var %d = $band(taskbar,_)
    if ($gettok(%d,1,32) == S_OK) {
      var %b = $gettok(%d,2,32), %l = $gettok(%d,3,32), %r = $gettok(%d,4,32), %t = $gettok(%d,5,32)

      if ($prop == x) { return %l }
      elseif ($prop == y) { return %t }
      elseif ($prop == w) { return $calc(%r - %l) }
      elseif ($prop == h) { return $calc(%b - %t) }
      elseif ($prop == pos) { return $iif((%r > $window(-1).w) && (%l > 0),right,$iif((%b > $window(-1).h) && (%t > 0),bottom,$iif((%b < $window(-1).h) && (%t < 0),top,left)))) }
    }
    else { prints ctcp * Error in $+($banddll,:) $gettok(%d,2-,32) }
  }
  return $null
}

; DLL Helpers - x-GUI
alias xgdll { return $supportdir(x-gui.dll) }
alias xg { return $dll($xgdll,$1,$2-) }

; DLL Helpers - cnick
alias cndll { return $supportdir(cnick.dll) }
alias cn { return $dll($cndll,$1,$2-) }

; DLL Helpers - registry
alias regdll { return $supportdir(registry2.dll) }
alias reg { return $dll($regdll,$1,$2-) }

; DLL Helpers - udock
alias udockdll { return $supportdir(ultradock.dll) }
alias udock { return $dll($udockdll,$1,$2-) }

; DLL Helpers - windowfx
alias wfxdll { return $supportdir(WindowFx.dll) }
alias wfx { return $dll($wfxdll,$1,$2-) }

; DLL Helpers - essence
alias essdll { return $supportdir(Essence.dll) }
alias ess { return $dll($essdll,$1,$2-) }

alias filetype {
  if ($1 != $null) {
    var %e = $gettok($1,$gettok($1,0,46),46)
    if ($prop == reftype) { return $reg(GetKeyValue,$+(HKEY_CLASSES_ROOT\.,%e,\\)) }
    elseif ($prop == systype) { return $reg(GetKeyValue,$+(HKEY_CLASSES_ROOT\.,%e,\\PerceivedType)) }
    elseif ($prop == mimetype) { return $reg(GetKeyValue,$+(HKEY_CLASSES_ROOT\.,%e,\\Content Type)) }
    elseif ($prop == type) { 
      var %r = $reg(GetKeyValue,$+(HKEY_CLASSES_ROOT\.,%e,\\)) 
      if (%r != $null) {
        return $reg(GetKeyValue,$+(HKEY_CLASSES_ROOT\,%r,\\))
      }
    }
    elseif ($prop == icon) { 
      var %r = $reg(GetKeyValue,$+(HKEY_CLASSES_ROOT\.,%e,\\)), %i = $null
      if (%r != $null) {
        var %i = $reg(GetKeyValue,$+(HKEY_CLASSES_ROOT\,%r,\DefaultIcon\\))
      }      
      if (%i == $null) { var %i = $+(%,SystemRoot,%,\system32\shell32.dll,$chr(37),1) }
      if (%i != $null) {
        var %f = $gettok(%i,1,44), %d = $gettok(%i,2,44)
        if (%f != $null) {
          return $+($evalenv(%f),$chr(44),$iif(%d,$iif(%d > 0,$calc(%d - 1),$calc(-1 - %d)),0))
        }
      }
    }
    elseif ($prop == open) { 
      var %r = $reg(GetKeyValue,$+(HKEY_CLASSES_ROOT\.,%e,\\))
      if (%r != $null) {
        return $reg(GetKeyValue,$+(HKEY_CLASSES_ROOT\,%r,\shell\open\command\\))
      }
    }
    elseif ($prop == withdot) { return $+(.,%e) }
    else { return %e }
  }
  return $null
}

alias env {
  var %a = envar $+ $ticks, %r
  if ($com(%a)) { .comclose %a }
  .comopen %a WScript.Shell
  .timer 1 5 .comclose %a
  if ($comerr) { return }
  .echo -q $com(%a,ExpandEnvironmentStrings,3,bstr,$+(%,$1,%))
  %r = $com(%a).result
  .comclose %a
  if ($left(%r,1) $right(%r,1) == % %) { return $null }
  return %r
}

alias evalenv {
  if ($chr(37) isin $1) {
    var %x = 1, %i = $gettok($1,0,32), %o = $null
    while (%x <= %i) {
      var %c = $gettok($1,%x,32)
      if ($chr(37) isin %c) {
        var %y = 1, %j = $len(%c), %p = 0, %q = $null, %r = $null
        while (%y <= %j) {
          var %d = $mid(%c,%y,1)
          if (%d == $chr(37)) {
            if (%p == 1) {
              var %p = 0
              var %r = $+(%r,$env(%q))
            }
            else {
              var %q = $null
              var %p = 1 
            }
          }
          elseif (%p == 1) { var %q = $+(%q,%d) }
          else { var %r = $+(%r,%d) }
          inc %y
        }
        var %o = $+($iif(%o,%o ),%r)
      }
      else { var %o = $+($iif(%o,%o ),%c) }
      inc %x
    }
    return %o
  }
  else { return $1- }
}

alias c {
  var %x = 1, %y = $window(*,0)
  while (%x <= %y) {
    var %z = $window(*,%x)
    window -g0 $enclose(%z)
    inc %x
  }
}
alias ca { scon -a c }

alias sing { me ♫ $1- ♫ }
alias think { me .oO( $1- ) }
alias bmode {
  var %a = $+(%bmode. [ $+ [ $1 ] $+ ] .a,$2)
  if (%a != $null) {
    var %m = 1, %n = 0, %w = +, %x = 1, %y = $len(%a)
    unset %bmode. [ $+ [ $1 ] $+ ] .a
    unset %bmode. [ $+ [ $1 ] $+ ] .a
    while (%x <= %y) {
      var %z = $mid(%a,%x,1)
      if (%z == +) { 
        if ((%w != %z) || (%x == 1)) {
          set %bmode. [ $+ [ $1 ] $+ ] .a $+(%bmode. [ $+ [ $1 ] $+ ] .a,%z)
        }
        var %w = + 
      }
      elseif (%z == -) {
        if (%w != %z) {
          set %bmode. [ $+ [ $1 ] $+ ] .a $+(%bmode. [ $+ [ $1 ] $+ ] .a,%z)
        }
        var %w = - 
      }
      else {
        set %bmode. [ $+ [ $1 ] $+ ] .a $+(%bmode. [ $+ [ $1 ] $+ ] .a,%z)
        if ($isvar(%z)) {
          var %b = %bmode. [ $+ [ $1 ] $+ ] .b
          set %bmode. [ $+ [ $1 ] $+ ] .b $+(%b,$chr(32),$gettok($3-,%m,32))
          inc %m
        }
        inc %n 
        if (%n >= $isupport($cid).MODES) {
          fmode $1 
          var %n = 0
        }
      }
      inc %x
    }
  }
  if (%bmode. [ $+ [ $1 ] $+ ] .a != $null) { .timer_bmode_ [ $+ [ $1 ] ] 1 3 fmode $1 }
}

alias fmode {
  if (($me isop $1) || ($me ishop $1)) {
    var %a = %bmode. [ $+ [ $1 ] $+ ] .a
    var %b = %bmode. [ $+ [ $1 ] $+ ] .b
    if (%a != $null) {
      if (%b != $null) { mode $1 %a %b }
      else { mode $1 %a }
    }
  }
  unset %bmode. [ $+ [ $1 ] $+ ] .*
  .timer_bmode_ [ $+ [ $1 ] ] off
}


alias mass {
  if (($1 ischan) && (($me isop $1) || ($me ishop $1))) {
    var %a = $iif($3 != $null,$3,*)
    var %b = $left($2,1)
    var %c = $right($2,1)
    if (((%b == +) || (%b == -)) && ($ismod(%c))) {
      var %x = 1, %y = $ialchan(%a,$1,0)
      while (%x <= %y) {
        var %q = $ialchan(%a,$1,%x).nick
        if (%q != $me) { bmode $1 $2 %q }
        inc %x
      }
    }
    elseif ($2 == op) { .timer 1 1 mass $1 +o %a }
    elseif ($2 == deop) { .timer 1 1 mass $1 -o %a }
    elseif ($2 == voice) { .timer 1 1 mass $1 +v %a }
    elseif ($2 == devoice) { .timer 1 1 mass $1 -v %a }
    else { printa info * /mass: <#chan> <[+/-[mode]]|[op|deop|voice|devoice]> [mask] | printa info2 * /mass: $1 $2 $3 -> %a %b %c }
  }
  else { printa info * /mass: You're not an operator on $1 }
}

alias dokick {
  if (($me ison $1) && (($me isop $1) || ($me ishop $1))) {
    mode $1 +b $fban($2)
    .timer 1 3 bmode $1 -b $fban($2)
    if ($2 ison $1) { kick $1 $2 $iif($3 != $null,$3-,Requested) }
  }
}

alias mkick {
  if (($me ison $1) && (($me isop $1) || ($me ishop $1))) {
    var %x = $nick($1,0), %y = 1
    while (%x >= %y) {
      var %z = $nick($1,%y)
      if (%z != $me) { kick $1 %z $iif($2 != $null,$2-,Requested) }
      inc %y
    }
  }
}

alias doban {
  if (($me ison $1) && (($me isop $1) || ($me ishop $1))) {
    mode $1 +b $fban($2)
    if ($2 ison $1) { kick $1 $2 $iif($3 != $null,$3-,You are banned) }
  }
}

alias doquiet {
  if (($me ison $1) && (($me isop $1) || ($me ishop $1))) {
    if ($network == freenode) { mode $1 +q $fban($2) }
    else { mode $1 +b $+(~q:,$fban($2)) }
    if (($2 ison $1) && ($3 != $null)) { msg $1 $+($2,:) You are silenced - $3- }
  }
}

alias dobq {
  var %tok = 1, %chan = $null

  if ($gettok($2-,%tok,32) ischan) { var %chan = $gettok($2-,%tok,32) | inc %tok }
  elseif ($active ischan) { var %chan = $active }

  if (%chan != $null) {
    if (($me isop %chan) || ($me ishop %chan)) {
      var %user = $gettok($2-,%tok,32)
      inc %tok
      if (%user ison %chan) {
        var %reas = $gettok($2-,$+(%tok,-),32)
        $1 %chan %user %reas
      }
      else { printa info * No such user }
    }
    else { printa info * No access to channel }
  }
  else { printa info * No channel specified }
}

alias k { dobq dokick $1- }
alias kb { dobq doban $1- }
alias quiet { dobq doquiet $1- }
